
module BBFlow
  class Options
    class << self
      ALLOWED_OPTIONS = {
        base_branch: { default_value: 'master' },
        commit_message: {}
      }

      # @param [Symbol] name
      # @param [Object] value
      #
      # @raise [ArgumentError]
      # @return [void]
      def set(name, value)
        raise ArgumentError "Trying to set an unknown option #{name}" unless ALLOWED_OPTIONS.keys.include?(name)

        @storage ||= {}
        @storage[name] = value
      end

      # @param [Symbol] name
      #
      # @raise [ArgumentError]
      # @return [Object]
      def get(name)
        raise ArgumentError, "Trying to get an unknown option #{name}" unless ALLOWED_OPTIONS.keys.include?(name)

        @storage ||= {}
        @storage[name] || default(name)
      end

      # @param [Symbol] name
      #
      # @raise [ArgumentError]
      # @return [Object]
      def default(name)
        raise ArgumentError, "Trying to get a default for an unknown option #{name}" unless ALLOWED_OPTIONS.keys.include?(name)

        ALLOWED_OPTIONS[name][:default_value]
      end
    end
  end
end
